<?php


//$output = "results/".$_FILES['userfile']['name'];

$CPcount = 0;
$Spline = 0;
$Bones = 0;
$step = 0;

$Infoprint = "";
$debug = 0;

if (!isset($Right)) $Right = 1;  // 0 = Left
if (!isset($Rightprefix)) $Rightprefix = "Right ";
if (!isset($Leftprefix)) $Leftprefix = "Left ";

function microtime_float() 
{ 
   list($usec, $sec) = explode(" ", microtime()); 
   return ((float)$usec + (float)$sec); 
}


$CPstats = array(	"centers" => 0,
			"mirrors" => 0,
			"welded" => 0,
			"hooks" => 0,
			"hooks mirrored" => 0,
			"no mirror" => 0,
			"errors" => 0,
			"welds added" => 0,
			"Overall time" => microtime_float(),
			"Bones" => 0,
		);


if (is_array($readfile))
{

$CPstats["Read time"] = microtime_float();

	while (list($i,$line) = each ($readfile))
	{

		if (substr($line,0 ,7) == "[BONES]") {$Bones = 1;}
		if (substr($line,0 ,10) == "[ENDBONES]") $Bones = 4;

		if (substr($line,0 ,18) == "[ENDNONSKINNEDCPS]")
		{
			$Bones = 1;
			$BoneC[$Bonename] = $Boneassigned;
				
		}

		if (substr($line,0 ,16) == "[ENDWEIGHTEDCPS]")
		{
			$Bones = 1;
			$BoneW[$Bonename] = $Boneweights;
		}

		if ($Bones > 0 && $Bones < 4 && substr($line,0 ,4) == "Name")
		{
			$Bonename = substr(rtrim($line), 5);
			$BoneW[$Bonename] = "";
			$BoneC[$Bonename] = "";
			$Boneweights = "";
			$Boneassigned = "";
  		$CPstats["Bones"]++;
		}

		if ($Bones == 3 && substr($line,0 ,5) != "Count")
		{	$Boneweights = $Boneweights.$line; }

		if ($Bones == 2 && substr($line,0 ,5) != "Count")
		{	$Boneassigned = $Boneassigned.$line; }


		if (substr($line,0 ,13) == "[WEIGHTEDCPS]") $Bones = 3; 
		if (substr($line,0 ,15) == "[NONSKINNEDCPS]") $Bones = 2;


		if ($Spline == 1) $Spline = 2;
		if (substr($line,0 ,2) == "CP" && $Spline != 3) {$Spline = 1; $step = 0;}


		if ($Spline == 2 && substr($line,0 ,9) == "[ENDMESH]") $Spline = 3;

		// READ CPs
		if ($Spline == 2) 
		{
			if ($step == 0)
			{
				$hook = 0;
				$cpline = explode(" ",$line);
				if ($cpline[1] == 1)
				{	$cpconnected = 1;
					if (isset($cpline[3])) { $CPstats["hooks"]++; $hook = 1; }
				}
				else $cpconnected = 0;
				$cpid = rtrim($cpline[2]);

			}
			if ($step == 1) {


				if ($cpconnected)
				{	$CPs[$cpid] = "w".trim($line);
					$WELDs[trim($line)] = $cpid;
					if ($hook) $HOOKs[trim($line)] = $cpid;
				} 
				else
				{
					$tol = explode(" ",trim($line));
					$tol[0] = round($tol[0], 3);
					$tol[1] = round($tol[1], 3);
					$tol[2] = round($tol[2], 3);
					$ToleratedPos = $tol[0]." ".$tol[1]." ".$tol[2];
					$CPs[$cpid] = $ToleratedPos;
					$OPOS[$ToleratedPos] = $cpid;
				}

			}

			if ($step >= 3) $step = 0;
			else $step++;
		} //end read cps

	}// END COLLECT DATA

$CPstats["Read time"] = microtime_float()-$CPstats["Read time"];

} //READ FILE
else
{
	exit ("<b>No file!</b>");
}


if (isset($CPs)) // START BUILDING MIRROR TABLE
{

$CPstats["Mirror time"] = microtime_float();


	$TCPs = $CPs;
	reset($TCPs);

	while (list($cp,$pos) = each ($TCPs))
	{
		$usethis = false;
		if (substr($pos,0,1) != "w")
		{
			$Position = explode(" ",$pos);


			$TestPosition = (-1 * $Position[0])." ".$Position[1]." ".$Position[2];

			if ($Position[0] == 0) 		
			{
				$MCPs[$cp] = $cp;
				$CPstats["centers"]++;
				$usethis = $cp;

			} // Position test
			else  // ($Position[0] != 0) 
			{	
				if (isset($OPOS[$TestPosition]))
				{
					$MCPs[$cp] = $OPOS[$TestPosition];
					$CPstats["mirrors"]++;
				}
				else
				{	$MCPs[$cp] = "no mirror";
					$CPstats["no mirror"]++;
				}
			}

		} 
		else
		{
			$MCPs[$cp] = $pos;
			$CPstats["welded"]++;
		} // if $pos
			
	} // while $TCPs

	unset($TCPs);
	reset($MCPs);


$CPstats["Mirror time"] = microtime_float()-$CPstats["Mirror time"];


} //END MIRROR TABLE


// MIRROR BONE DATA
$BoneC2 = $BoneC;


$CPstats["Bone time"] = microtime_float();
while (list($bone,$assigned) = each ($BoneC2))
{

	// Right -X ___  Left +X
	
	if (substr($bone, 0, strlen($Rightprefix)) == $Rightprefix) $Type = "R";
	else if (substr($bone, 0, strlen($Leftprefix)) == $Leftprefix) $Type = "L";
	else $Type = "M";

	$mirrorbone = 0;
	if ($Type == "L" && $Right == 1)
		$mirrorbone = $Rightprefix.substr($bone, strlen($Leftprefix));
	else if ($Type == "R" && $Right == 0)
		$mirrorbone = $Leftprefix.substr($bone, strlen($Rightprefix));
	else if ($Type == "M")
		$mirrorbone = $bone;
	else $mirrorbone = 0;

	if ($mirrorbone)  // Right -> Left only atm.
	{
		
		$Infoprint = $Infoprint."".$mirrorbone." ===> ".$bone."\n";

		// MIRROR NORMAL CPs
		$nonskinned = explode("\n", trim($BoneC[$mirrorbone]));

		$newcps = "";


		if (trim($nonskinned[0]) != "")
		{	while (list($i,$cp) = each ($nonskinned))
			{	
				$includehook = 0;
				if ($cp && isset($MCPs[trim($cp)])) $mirrorcp = $MCPs[trim($cp)];
				else {$CPstats["errors"]++;}
				if (substr($mirrorcp, 0, 1) == "w") {} //{ $includehook = substr($mirrorcp, 1);}
				else if ($mirrorcp == "center") {} // { $includehook = $cp;}
				else if ($mirrorcp == "no mirror") {}
				else if ($mirrorcp > 0)
				{	//echo $cp."->".$mirrorcp."<br>";

					//master CPs last, or fuckups will happen
					if (isset($WELDs[$mirrorcp]))
					{	$newcps = $newcps."\n".$WELDs[$mirrorcp];
						$CPstats["welds added"]++;
					}

					// HOOKs is trouble ??
					$includehook = trim($includehook);
					if ($includehook && isset($HOOKs[$includehook]))
					{	//echo "hook ".$includehook." -> ".$HOOKs[$includehook]."\n";
						$newcps = $newcps."\n".$HOOKs[$includehook];
						$CPstats["hooks mirrored"]++;
					}

					$newcps = $newcps."\n".$mirrorcp;

					$includehook = $mirrorcp;
				}
				else $Infoprint = $Infoprint."Error with CP ".$cp." mirror: ".$mirrorcp."\n";

				
				$mirrorcp = 0;

			}
		}
		if ($Type == "L" || $Type == "R")
			$BoneC[$bone] = trim($newcps);
		else
		{
			$existcps = trim($BoneC[$bone]);
			$newcps = trim($newcps);
			$BoneC[$bone] = $existcps."\n".$newcps;
		}

		// MIRROR WEIGHTED CPs
		$mirrorcp = 0;
		$weighted = explode("\n", $BoneW[$mirrorbone]);
	 	$newWcps = "";

		while (list($i,$cp) = each ($weighted))
		{	
			$cpw = explode(" ", rtrim($cp));
			//if ($cpw[0])	$mirrorcp = $MCPs[$cpw[0]];
			if (isset($MCPs[$cpw[0]]))	$mirrorcp = $MCPs[$cpw[0]];
			if (substr($mirrorcp, 0, 1) == "w") {}
			else if ($mirrorcp == "center") {}
			else if ($mirrorcp > 0)
			{	//echo $cpw[0]."->".$mirrorcp." W=".$cpw[1]."<br>";
				$newWcps = $newWcps."\n".$mirrorcp." ".$cpw[1];
			}
			else $Infoprint = $Infoprint."E!";
			$mirrorcp = 0;
		}


		if ($Type == "L" || $Type == "R")
			$BoneW[$bone] = trim($newWcps);
		else
		{
			$newWcps = trim($newWcps);
			$BoneW[$bone] = trim($BoneW[$bone])."\n".$newWcps;
		}

		//REMOVE dublicates in middle bones:

		if ($Type == "M")
		{


			//non weighted
			$middlecps = explode("\n", $BoneC[$bone]);

			while (list($id,$ecp) = each($middlecps))
			{	$uniquecps[trim($ecp)] = $ecp;}
			$newcps = "";
			while (list($id,$ucp) = each($uniquecps))
			{	$newcps = $newcps."\n".$id; }

			$BoneC[$bone] = ltrim($newcps);


			// Weighted
			$middlecps = explode("\n", $BoneW[$bone]);

			while (list($id,$ecp) = each($middlecps))
			{	
				$uniquecps[trim($ecp)] = $ecp;
			}
			$newcps = "";
			while (list($id,$ucp) = each($uniquecps))
			{	$newcps = $newcps."\n".$id; }

			$BoneW[$bone] = ltrim($newcps);

		}


	}
	else
	{
		$BoneC[$bone] = trim($BoneC[$bone]);
		$BoneW[$bone] = trim($BoneW[$bone]);
		//echo "<b>".$bone." trimmed</b>\n";
	}
}

unset($BoneC2);
$CPstats["Bone time"] = microtime_float()-$CPstats["Bone time"];


$CPstats["File time"] = microtime_float();
reset($readfile);
$Bones = 0;
$CurrentBone = "";
$nline = 0;
while (list($i,$line) = each ($readfile))
{

	if (substr($line,0 ,9) == "BoneColor") $Bones = 1;

	if (substr($line,0 ,7) == "[BONES]") $Bones = 1;

	if ($Bones < 2) { $Newfile[$nline] = trim($line)."\n"; $nline++; }
	if (substr($line,0 ,14) == "LastModifiedBy") $Newfile[$nline-1] = "LastModifiedBy=PHP weight flipper\n";
	

	if ($Bones && substr($line,0 ,4) == "Name")
	{ 
		$CurrentBone = substr(rtrim($line), 5);
		$Newfile[$nline] = "Name=".$CurrentBone."\n";

		if (substr($BoneC[$CurrentBone], 0 , 1) > 0)
		{
			$CPstr = trim($BoneC[$CurrentBone]);
			$CPcount = substr_count($CPstr, "\n")+1;
			$Newfile[$nline] = "[NONSKINNEDCPS]\n"."Count=".$CPcount."\n".$CPstr."\n"."[ENDNONSKINNEDCPS]\n";
			$nline++;
		}
		if (substr($BoneW[$CurrentBone], 0 , 1) > 0)
		{
			$CPstr = trim($BoneW[$CurrentBone]);
			$CPcount = substr_count($CPstr, "\n")+1;
			$Newfile[$nline] = "[WEIGHTEDCPS]\n"."Count=".$CPcount."\n".$CPstr."\n"."[ENDWEIGHTEDCPS]\n";
			$nline++;
		}
		$Bones = 3;
	}


	if (substr($line,0 ,10) == "[ENDBONES]") $Bones = 0;
	

}
$CPstats["File time"] = microtime_float()-$CPstats["File time"];

if ($Newfile && isset($output))
{
	$CPstats["Write time"] = microtime_float();

	$file = fopen($output, "w");
	while (list($i,$segment) = each($Newfile))
	{
		//fwrite($file, "\n");
		fwrite($file, $segment);
	}
	fclose($file);
	$CPstats["Write time"] = microtime_float()-$CPstats["Write time"];

}
else if ($Newfile)
{
	header('Content-type: text/AM');
	$saveheader = "Content-Disposition: attachment; filename=\"".$newname."\"";
  header($saveheader);
//	echo "[MODELFILE]\n";
	while (list($i,$segment) = each($Newfile))
	{
		echo $segment;
	}


}

// ===== DEBUG INFO =====


$CPstats["Overall time"] = microtime_float()-$CPstats["Overall time"];

$CPstats["CP count"] = sizeof($CPs);

$Infoprint = $Infoprint."\n\n";

while (list($i,$str) = each ($CPstats))
{ $Infoprint = $Infoprint.$i." = ".$str."\n"; }



if ($debug)  // write log
{

	$file = fopen("latestprocess.txt", "w");
	fwrite($file, $Infoprint);
	fclose($file);

}

?>